#include "misc.h"

/*--------------------------------------------------------------------------+
| portable_catch_termination_signals										|
+--------------------------------------------------------------------------*/
void
portable_catch_termination_signals(handler)
	void	(*handler)();
{
	/*
	 * Catch all signals causing process termination.
	 * Signal causing a core dump are not caught, except SIGABRT.
	 */

	/* The following 6 signals are defined by ANSI C */
	(void)signal(SIGABRT, handler);
	(void)signal(SIGINT, handler);
	(void)signal(SIGTERM, handler);
	(void)signal(SIGILL, handler);
	(void)signal(SIGFPE, handler);
	(void)signal(SIGSEGV, handler);

#ifdef _POSIX_SOURCE
	(void)signal(SIGHUP, handler);
#ifndef DEBUG
	(void)signal(SIGQUIT, handler);
#endif /* not DEBUG */
#endif /* _POSIX_SOURCE */

	/*
	 * Implementation dependent signals
	 */
#if defined(ARCH_sun4) || defined(ARCH_sun4gcc)
	(void)signal(SIGTRAP, handler);
	(void)signal(SIGEMT, handler);
#ifndef DEBUG
	(void)signal(SIGSYS, handler);
	(void)signal(SIGLOST, handler);
#endif /* not DEBUG */
	(void)signal(SIGPIPE, handler);
#ifndef PTHREAD
	(void)signal(SIGALRM, handler);
#endif
	(void)signal(SIGXCPU, handler);
	(void)signal(SIGXFSZ, handler);
	(void)signal(SIGVTALRM, handler);
	(void)signal(SIGPROF, handler);
	(void)signal(SIGUSR1, handler);
	(void)signal(SIGUSR2, handler);
#endif /* defined(ARCH_sun4) || defined(ARCH_sun4gcc) */
#if !defined(CONFIG_bsdi)
	(void)signal(SIGBUS, handler);
#endif
}
